(***********************************************************************)
(*                              Project Couverture                     *)
(*                                                                     *)
(* file: traceMcdc.ml                                                  *)
(* authors: Adrien Jonquet, Mathias Bourgoin                           *)
(* licence: CeCIL-B                                                    *)
(***********************************************************************)

type event = Covevent.coverage_event

(* MC/DC vector type *)
type mcdc_bool = Bool of bool | Unknown

type condition =
    { mutable cond_value : mcdc_bool;
      mutable nb_cond : int;
      mutable cond : event }

type decision =
    { mutable dec_value : mcdc_bool;
      mutable nb_dec : int;
      mutable dec : event }

type vector_model =
    {   mutable mod_dec : event;
        mutable mod_conds : event list }

type vector =
    { mutable nb_vec : int;
      mutable vec_dec : decision;
      mutable vec_conds :  condition array}

type mcdc =
    { mutable model : vector_model;
      mutable vectors : vector list }
